<div class="canvas-holder">

    <app-canvas-controls-component
            [config]="config"
            [colors]="colors"
            [width]="width"
            [isShowUndo]="stateIndex"
            [isShowRedo]="states.length > stateIndex"
            [settings]="controlSettings"
            (onCanvasClear)="clearCanvas($event)"
            (onColorChange)="colorChanged($event)"
            (onWidthChange)="widthChanged($event)"
            (onCanvasSave)="saveImage()"
            (onUndo)="undoImage()"
            (onRedo)="redoImage()"
            (onResize)="resizeImage($event)"
            (onFilterChange)="setFilter($event)">
    </app-canvas-controls-component>

    <app-file-select-component (onFileSelect)="uploadImage($event)"></app-file-select-component>
    <canvas #canvas [width]="config?.width" [height]="config?.height"></canvas>

</div>